078ed70197df5ef44697a6bd31bfc61c2ebef088
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2019 Cisco and/or its affiliates.
2 # Copyright (c) 2019 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # backtics to avoid https://midnight-commander.org/ticket/2142
57             env_vars=`${ssh} "$(declare -f); ${run}"` || {
58                 die "Topology reservation via shim-dcr failed!"
59             }
60             set -a
61             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
62                 die "Source failed!"
63             }
64             set +a
65             ;;
66         "1n_vbox")
67             # We execute reservation on localhost. Sourced script automatially
68             # sets environment variables for further processing.
69             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
70             ;;
71         *)
72             die "Unknown specification: ${case_text}!"
73     esac
74
75     trap 'deactivate_docker_topology' EXIT || {
76          die "Trap attempt failed, please cleanup manually. Aborting!"
77     }
78
79     # Replace all variables in template with those in environment.
80     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
81         die "Topology file create failed!"
82     }
83
84     WORKING_TOPOLOGY="/tmp/topology.yaml"
85     mv topo.yml "${WORKING_TOPOLOGY}" || {
86         die "Topology move failed!"
87     }
88     cat ${WORKING_TOPOLOGY} | grep -v password || {
89         die "Topology read failed!"
90     }
91 }
92
93
94 function activate_virtualenv () {
95
96     # Update virtualenv pip package, delete and create virtualenv directory,
97     # activate the virtualenv, install requirements, set PYTHONPATH.
98
99     # Arguments:
100     # - ${1} - Path to existing directory for creating virtualenv in.
101     #          If missing or empty, ${CSIT_DIR} is used.
102     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
103     # Variables read:
104     # - CSIT_DIR - Path to existing root of local CSIT git repository.
105     # Variables exported:
106     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
107     # Functions called:
108     # - die - Print to stderr and exit.
109
110     set -exuo pipefail
111
112     root_path="${1-$CSIT_DIR}"
113     env_dir="${root_path}/env"
114     req_path=${2-$CSIT_DIR/requirements.txt}
115     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
116     pip install --upgrade virtualenv || {
117         die "Virtualenv package install failed."
118     }
119     virtualenv "${env_dir}" || {
120         die "Virtualenv creation failed."
121     }
122     set +u
123     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
124     set -u
125     pip install --upgrade -r "${req_path}" || {
126         die "Requirements installation failed."
127     }
128     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
129     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
130 }
131
132
133 function archive_tests () {
134
135     # Create .tar.xz of generated/tests for archiving.
136     # To be run after generate_tests, kept separate to offer more flexibility.
137
138     # Directory read:
139     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
140     # File rewriten:
141     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
142
143     set -exuo pipefail
144
145     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
146         die "Error creating archive of generated tests."
147     }
148 }
149
150
151 function check_download_dir () {
152
153     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
154     #
155     # Variables read:
156     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
157     # Directories read:
158     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
159     # Functions called:
160     # - die - Print to stderr and exit.
161
162     set -exuo pipefail
163
164     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
165         die "No artifacts downloaded!"
166     fi
167 }
168
169
170 function cleanup_topo () {
171
172     # Variables read:
173     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
174     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
175
176     set -exuo pipefail
177
178     python "${PYTHON_SCRIPTS_DIR}/topo_cleanup.py" -t "${WORKING_TOPOLOGY}"
179     # Not using "|| die" as some callers might want to ignore errors,
180     # e.g. in teardowns, such as unreserve.
181 }
182
183
184 function common_dirs () {
185
186     # Set global variables, create some directories (without touching content).
187
188     # Variables set:
189     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
190     # - CSIT_DIR - Path to existing root of local CSIT git repository.
191     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
192     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
193     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
194     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
195     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
196     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
197     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
198     # Directories created if not present:
199     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
200     # Functions called:
201     # - die - Print to stderr and exit.
202
203     set -exuo pipefail
204
205     BASH_FUNCTION_DIR="$(dirname "$(readlink -e "${BASH_SOURCE[0]}")")" || {
206         die "Some error during localizing this source directory."
207     }
208     # Current working directory could be in a different repo, e.g. VPP.
209     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
210     CSIT_DIR="$(readlink -e "$(git rev-parse --show-toplevel)")" || {
211         die "Readlink or git rev-parse failed."
212     }
213     popd || die "Popd failed."
214     TOPOLOGIES_DIR="$(readlink -e "${CSIT_DIR}/topologies/available")" || {
215         die "Readlink failed."
216     }
217     RESOURCES_DIR="$(readlink -e "${CSIT_DIR}/resources")" || {
218         die "Readlink failed."
219     }
220     TOOLS_DIR="$(readlink -e "${RESOURCES_DIR}/tools")" || {
221         die "Readlink failed."
222     }
223     PYTHON_SCRIPTS_DIR="$(readlink -e "${TOOLS_DIR}/scripts")" || {
224         die "Readlink failed."
225     }
226
227     ARCHIVE_DIR="$(readlink -f "${CSIT_DIR}/archive")" || {
228         die "Readlink failed."
229     }
230     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
231     DOWNLOAD_DIR="$(readlink -f "${CSIT_DIR}/download_dir")" || {
232         die "Readlink failed."
233     }
234     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
235     GENERATED_DIR="$(readlink -f "${CSIT_DIR}/generated")" || {
236         die "Readlink failed."
237     }
238     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
239 }
240
241
242 function compose_pybot_arguments () {
243
244     # Variables read:
245     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
246     # - DUT - CSIT test/ subdirectory, set while processing tags.
247     # - TAGS - Array variable holding selected tag boolean expressions.
248     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
249     # - TEST_CODE - The test selection string from environment or argument.
250     # Variables set:
251     # - PYBOT_ARGS - String holding part of all arguments for pybot.
252     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
253
254     set -exuo pipefail
255
256     # No explicit check needed with "set -u".
257     PYBOT_ARGS=("--loglevel" "TRACE")
258     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
259
260     case "${TEST_CODE}" in
261         *"device"*)
262             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
263             ;;
264         *"func"*)
265             PYBOT_ARGS+=("--suite" "tests.${DUT}.func")
266             ;;
267         *"perf"*)
268             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
269             ;;
270         *)
271             die "Unknown specification: ${TEST_CODE}"
272     esac
273
274     EXPANDED_TAGS=()
275     for tag in "${TAGS[@]}"; do
276         if [[ ${tag} == "!"* ]]; then
277             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
278         else
279             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
280         fi
281     done
282 }
283
284
285 function copy_archives () {
286
287     # Create additional archive if workspace variable is set.
288     # This way if script is running in jenkins all will be
289     # automatically archived to logs.fd.io.
290     #
291     # Variables read:
292     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
293     #   Can be unset, then it speeds up manual testing.
294     # - ARCHIVE_DIR - Path to directory with content to be copied.
295     # Directories updated:
296     # - ${WORKSPACE}/archives/ - Created if does not exist.
297     #   Content of ${ARCHIVE_DIR}/ is copied here.
298     # Functions called:
299     # - die - Print to stderr and exit.
300
301     set -exuo pipefail
302
303     if [[ -n "${WORKSPACE-}" ]]; then
304         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
305         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
306     fi
307 }
308
309
310 function deactivate_docker_topology () {
311
312     # Deactivate virtual vpp-device topology by removing containers.
313     #
314     # Variables read:
315     # - NODENESS - Node multiplicity of desired testbed.
316     # - FLAVOR - Node flavor string, usually describing the processor.
317
318     set -exuo pipefail
319
320     case_text="${NODENESS}_${FLAVOR}"
321     case "${case_text}" in
322         "1n_skx")
323             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
324             ssh="ssh root@${hostname} -p 6022"
325             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
326             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
327                 die "Topology cleanup via shim-dcr failed!"
328             }
329             ;;
330         "1n_vbox")
331             enter_mutex || die
332             clean_environment || {
333                 die "Topology cleanup locally failed!"
334             }
335             exit_mutex || die
336             ;;
337         *)
338             die "Unknown specification: ${case_text}!"
339     esac
340 }
341
342
343 function die () {
344
345     # Print the message to standard error end exit with error code specified
346     # by the second argument.
347     #
348     # Hardcoded values:
349     # - The default error message.
350     # Arguments:
351     # - ${1} - The whole error message, be sure to quote. Optional
352     # - ${2} - the code to exit with, default: 1.
353
354     set -x
355     set +eu
356     warn "${1:-Unspecified run-time error occurred!}"
357     exit "${2:-1}"
358 }
359
360
361 function die_on_pybot_error () {
362
363     # Source this fragment if you want to abort on any failed test case.
364     #
365     # Variables read:
366     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
367     # Functions called:
368     # - die - Print to stderr and exit.
369
370     set -exuo pipefail
371
372     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
373         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
374     fi
375 }
376
377
378 function generate_tests () {
379
380     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
381     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
382     # The generation is done by executing any *.py executable
383     # within any subdirectory after copying.
384
385     # This is a separate function, because this code is called
386     # both by autogen checker and entries calling run_pybot.
387
388     # Directories read:
389     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
390     # Directories replaced:
391     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
392
393     set -exuo pipefail
394
395     rm -rf "${GENERATED_DIR}/tests" || die
396     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
397     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
398     cmd_line+=("-executable" "-name" "*.py")
399     file_list=$("${cmd_line[@]}") || die
400
401     for gen in ${file_list}; do
402         directory="$(dirname "${gen}")" || die
403         filename="$(basename "${gen}")" || die
404         pushd "${directory}" || die
405         ./"${filename}" || die
406         popd || die
407     done
408 }
409
410
411 function get_test_code () {
412
413     # Arguments:
414     # - ${1} - Optional, argument of entry script (or empty as unset).
415     #   Test code value to override job name from environment.
416     # Variables read:
417     # - JOB_NAME - String affecting test selection, default if not argument.
418     # Variables set:
419     # - TEST_CODE - The test selection string from environment or argument.
420     # - NODENESS - Node multiplicity of desired testbed.
421     # - FLAVOR - Node flavor string, usually describing the processor.
422
423     set -exuo pipefail
424
425     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
426     if [[ -z "${TEST_CODE}" ]]; then
427         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
428     fi
429
430     case "${TEST_CODE}" in
431         *"1n-vbox"*)
432             NODENESS="1n"
433             FLAVOR="vbox"
434             ;;
435         *"1n-skx"*)
436             NODENESS="1n"
437             FLAVOR="skx"
438             ;;
439         *"2n-skx"*)
440             NODENESS="2n"
441             FLAVOR="skx"
442             ;;
443         *"3n-skx"*)
444             NODENESS="3n"
445             FLAVOR="skx"
446             ;;
447         *"2n-dnv"*)
448             NODENESS="2n"
449             FLAVOR="dnv"
450             ;;
451         *"3n-dnv"*)
452             NODENESS="3n"
453             FLAVOR="dnv"
454             ;;
455         *"3n-tsh"*)
456             NODENESS="3n"
457             FLAVOR="tsh"
458             ;;
459         *)
460             # Fallback to 3-node Haswell by default (backward compatibility)
461             NODENESS="3n"
462             FLAVOR="hsw"
463             ;;
464     esac
465 }
466
467
468 function get_test_tag_string () {
469
470     # Variables read:
471     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
472     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
473     # - TEST_CODE - The test selection string from environment or argument.
474     # Variables set:
475     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
476     #   May be empty, not set on event types not adding comment.
477
478     # TODO: ci-management scripts no longer need to perform this.
479
480     set -exuo pipefail
481
482     trigger=""
483     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
484         case "${TEST_CODE}" in
485             *"device"*)
486                 # On parsing error, ${trigger} stays empty.
487                 trigger="$(echo "${GERRIT_EVENT_COMMENT_TEXT}" \
488                     | grep -oE '(devicetest$|devicetest[[:space:]].+$)')" \
489                     || true
490                 # Set test tags as string.
491                 TEST_TAG_STRING="${trigger#$"devicetest"}"
492                 ;;
493             *"perf"*)
494                 # On parsing error, ${trigger} stays empty.
495                 comment="${GERRIT_EVENT_COMMENT_TEXT}"
496                 # As "perftest" can be followed by something, we substitute it.
497                 comment="${comment/perftest-2n/perftest}"
498                 comment="${comment/perftest-3n/perftest}"
499                 comment="${comment/perftest-hsw/perftest}"
500                 comment="${comment/perftest-skx/perftest}"
501                 comment="${comment/perftest-dnv/perftest}"
502                 comment="${comment/perftest-tsh/perftest}"
503                 tag_string="$(echo "${comment}" \
504                     | grep -oE '(perftest$|perftest[[:space:]].+$)' || true)"
505                 # Set test tags as string.
506                 TEST_TAG_STRING="${tag_string#$"perftest"}"
507                 ;;
508             *)
509                 die "Unknown specification: ${TEST_CODE}"
510         esac
511     fi
512 }
513
514
515 function reserve_and_cleanup_testbed () {
516
517     # Reserve physical testbed, perform cleanup, register trap to unreserve.
518     # When cleanup fails, remove from topologies and keep retrying
519     # until all topologies are removed.
520     #
521     # Variables read:
522     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
523     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
524     # - BUILD_TAG - Any string suitable as filename, identifying
525     #   test run executing this function. May be unset.
526     # - BUILD_URL - Any string suitable as URL, identifying
527     #   test run executing this function. May be unset.
528     # Variables set:
529     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
530     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
531     # Functions called:
532     # - die - Print to stderr and exit.
533     # Traps registered:
534     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
535
536     set -exuo pipefail
537
538     while [[ ${TOPOLOGIES[@]} ]]; do
539         for topo in "${TOPOLOGIES[@]}"; do
540             set +e
541             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
542             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
543             opts+=("-u" "${BUILD_URL:-Unknown}")
544             python "${scrpt}" "${opts[@]}"
545             result="$?"
546             set -e
547             if [[ "${result}" == "0" ]]; then
548                 # Trap unreservation before cleanup check,
549                 # so multiple jobs showing failed cleanup improve chances
550                 # of humans to notice and fix.
551                 WORKING_TOPOLOGY="${topo}"
552                 echo "Reserved: ${WORKING_TOPOLOGY}"
553                 trap "untrap_and_unreserve_testbed" EXIT || {
554                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
555                     untrap_and_unreserve_testbed "${message}" || {
556                         die "Teardown should have died, not failed."
557                     }
558                     die "Trap attempt failed, unreserve succeeded. Aborting."
559                 }
560                 # Cleanup check.
561                 set +e
562                 cleanup_topo
563                 result="$?"
564                 set -e
565                 if [[ "${result}" == "0" ]]; then
566                     break
567                 fi
568                 warn "Testbed cleanup failed: ${topo}"
569                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
570                 # WORKING_TOPOLOGY is now empty again.
571                 # Build new topology array.
572                 #   TOPOLOGIES=("${TOPOLOGIES[@]/$topo}")
573                 # does not really work, see:
574                 # https://stackoverflow.com/questions/16860877/remove-an-element-from-a-bash-array
575                 new_topologies=()
576                 for item in "${TOPOLOGIES[@]}"; do
577                     if [[ "${item}" != "${topo}" ]]; then
578                         new_topologies+=("${item}")
579                     fi
580                 done
581                 TOPOLOGIES=("${new_topologies[@]}")
582                 break
583             fi
584         done
585
586         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
587             # Exit the infinite while loop if we made a reservation.
588             break
589         fi
590
591         # Wait ~3minutes before next try.
592         sleep_time="$[ ( $RANDOM % 20 ) + 180 ]s" || {
593             die "Sleep time calculation failed."
594         }
595         echo "Sleeping ${sleep_time}"
596         sleep "${sleep_time}" || die "Sleep failed."
597     done
598     if [[ ${TOPOLOGIES[@]} ]]; then
599         echo "Reservation and cleanup successful."
600     else
601         die "Run out of operational testbeds!"
602     fi
603 }
604
605
606 function run_pybot () {
607
608     # Run pybot with options based on input variables. Create output_info.xml
609     #
610     # Variables read:
611     # - CSIT_DIR - Path to existing root of local CSIT git repository.
612     # - ARCHIVE_DIR - Path to store robot result files in.
613     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
614     # - GENERATED_DIR - Tests are assumed to be generated under there.
615     # Variables set:
616     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
617     # Functions called:
618     # - die - Print to stderr and exit.
619
620     set -exuo pipefail
621
622     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
623     all_options+=("--noncritical" "EXPECTED_FAILING")
624     all_options+=("${EXPANDED_TAGS[@]}")
625
626     pushd "${CSIT_DIR}" || die "Change directory operation failed."
627     set +e
628     pybot "${all_options[@]}" "${GENERATED_DIR}/tests/"
629     PYBOT_EXIT_STATUS="$?"
630     set -e
631
632     # Generate INFO level output_info.xml for post-processing.
633     all_options=("--loglevel" "INFO")
634     all_options+=("--log" "none")
635     all_options+=("--report" "none")
636     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
637     all_options+=("${ARCHIVE_DIR}/output.xml")
638     rebot "${all_options[@]}" || true
639     popd || die "Change directory operation failed."
640 }
641
642
643 function select_tags () {
644
645     # Variables read:
646     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
647     # - TEST_CODE - String affecting test selection, usually jenkins job name.
648     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
649     #   Can be unset.
650     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
651     # - BASH_FUNCTION_DIR - Directory with input files to process.
652     # Variables set:
653     # - TAGS - Array of processed tag boolean expressions.
654
655     set -exuo pipefail
656
657     # NIC SELECTION
658     start_pattern='^  TG:'
659     end_pattern='^ \? \?[A-Za-z0-9]\+:'
660     # Remove the TG section from topology file
661     sed_command="/${start_pattern}/,/${end_pattern}/d"
662     # All topologies DUT NICs
663     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
664                 | grep -hoP "model: \K.*" | sort -u)
665     # Selected topology DUT NICs
666     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
667                | grep -hoP "model: \K.*" | sort -u)
668     # All topologies DUT NICs - Selected topology DUT NICs
669     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
670         die "Computation of excluded NICs failed."
671     }
672
673     # Select default NIC tag.
674     case "${TEST_CODE}" in
675         *"3n-dnv"* | *"2n-dnv"*)
676             default_nic="nic_intel-x553"
677             ;;
678         *"3n-tsh"*)
679             default_nic="nic_intel-x520-da2"
680             ;;
681         *)
682             default_nic="nic_intel-x710"
683             ;;
684     esac
685
686     # Tag file directory shorthand.
687     tfd="${BASH_FUNCTION_DIR}"
688     case "${TEST_CODE}" in
689         # Select specific performance tests based on jenkins job type variable.
690         *"ndrpdr-weekly"* )
691             readarray -t test_tag_array < "${tfd}/mlr-weekly.txt" || die
692             ;;
693         *"mrr-daily"* )
694             readarray -t test_tag_array < "${tfd}/mrr-daily.txt" || die
695             ;;
696         *"mrr-weekly"* )
697             readarray -t test_tag_array < "${tfd}/mrr-weekly.txt" || die
698             ;;
699         * )
700             if [[ -z "${TEST_TAG_STRING-}" ]]; then
701                 # If nothing is specified, we will run pre-selected tests by
702                 # following tags.
703                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
704                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
705                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
706                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
707                                 "!dot1q" "!drv_avf")
708             else
709                 # If trigger contains tags, split them into array.
710                 test_tag_array=(${TEST_TAG_STRING//:/ })
711             fi
712             ;;
713     esac
714
715     # Blacklisting certain tags per topology.
716     #
717     # Reasons for blacklisting:
718     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
719     # TODO: Add missing reasons here (if general) or where used (if specific).
720     case "${TEST_CODE}" in
721         *"2n-skx"*)
722             test_tag_array+=("!ipsechw")
723             ;;
724         *"3n-skx"*)
725             test_tag_array+=("!ipsechw")
726             # Not enough nic_intel-xxv710 to support double link tests.
727             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
728             ;;
729         *"2n-dnv"*)
730             test_tag_array+=("!ipsechw")
731             test_tag_array+=("!memif")
732             test_tag_array+=("!srv6_proxy")
733             test_tag_array+=("!vhost")
734             test_tag_array+=("!vts")
735             ;;
736         *"3n-dnv"*)
737             test_tag_array+=("!memif")
738             test_tag_array+=("!srv6_proxy")
739             test_tag_array+=("!vhost")
740             test_tag_array+=("!vts")
741             ;;
742         *"3n-tsh"*)
743             test_tag_array+=("!ipsechw")
744             test_tag_array+=("!memif")
745             test_tag_array+=("!srv6_proxy")
746             test_tag_array+=("!vhost")
747             test_tag_array+=("!vts")
748             ;;
749         *"3n-hsw"*)
750             # TODO: Introduce NOIOMMU version of AVF tests.
751             # TODO: Make (both) AVF tests work on Haswell,
752             # or document why (some of) it is not possible.
753             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
754             test_tag_array+=("!drv_avf")
755             # All cards have access to QAT. But only one card (xl710)
756             # resides in same NUMA as QAT. Other cards must go over QPI
757             # which we do not want to even run.
758             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
759             ;;
760         *)
761             # Default to 3n-hsw due to compatibility.
762             test_tag_array+=("!drv_avf")
763             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
764             ;;
765     esac
766
767     # We will add excluded NICs.
768     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
769
770     TAGS=()
771
772     # We will prefix with perftest to prevent running other tests
773     # (e.g. Functional).
774     prefix="perftestAND"
775     set +x
776     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
777         # Automatic prefixing for VPP jobs to limit the NIC used and
778         # traffic evaluation to MRR.
779         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
780             prefix="${prefix}mrrAND"
781         else
782             prefix="${prefix}mrrAND${default_nic}AND"
783         fi
784     fi
785     for tag in "${test_tag_array[@]}"; do
786         if [[ "${tag}" == "!"* ]]; then
787             # Exclude tags are not prefixed.
788             TAGS+=("${tag}")
789         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
790             # Empty and comment lines are skipped.
791             # Other lines are normal tags, they are to be prefixed.
792             TAGS+=("${prefix}${tag}")
793         fi
794     done
795     set -x
796 }
797
798
799 function select_vpp_device_tags () {
800
801     # Variables read:
802     # - TEST_CODE - String affecting test selection, usually jenkins job name.
803     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
804     #   Can be unset.
805     # Variables set:
806     # - TAGS - Array of processed tag boolean expressions.
807
808     set -exuo pipefail
809
810     case "${TEST_CODE}" in
811         # Select specific performance tests based on jenkins job type variable.
812         * )
813             if [[ -z "${TEST_TAG_STRING-}" ]]; then
814                 # If nothing is specified, we will run pre-selected tests by
815                 # following tags. Items of array will be concatenated by OR
816                 # in Robot Framework.
817                 test_tag_array=()
818             else
819                 # If trigger contains tags, split them into array.
820                 test_tag_array=(${TEST_TAG_STRING//:/ })
821             fi
822             ;;
823     esac
824
825     TAGS=()
826
827     # We will prefix with perftest to prevent running other tests
828     # (e.g. Functional).
829     prefix="devicetestAND"
830     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
831         # Automatic prefixing for VPP jobs to limit testing.
832         prefix="${prefix}"
833     fi
834     for tag in "${test_tag_array[@]}"; do
835         if [[ ${tag} == "!"* ]]; then
836             # Exclude tags are not prefixed.
837             TAGS+=("${tag}")
838         else
839             TAGS+=("${prefix}${tag}")
840         fi
841     done
842 }
843
844 function select_os () {
845
846     # Variables set:
847     # - VPP_VER_FILE - Name of File in CSIT dir containing vpp stable version.
848     # - IMAGE_VER_FILE - Name of File in CSIT dir containing the image name.
849     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
850
851     set -exuo pipefail
852
853     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
854         die "Get OS release failed."
855     }
856
857     case "${os_id}" in
858         "ubuntu"*)
859             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
860             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
861             PKG_SUFFIX="deb"
862             ;;
863         "centos"*)
864             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
865             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
866             PKG_SUFFIX="rpm"
867             ;;
868         *)
869             die "Unable to identify distro or os from ${OS}"
870             ;;
871     esac
872 }
873
874
875 function select_topology () {
876
877     # Variables read:
878     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
879     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
880     # - CSIT_DIR - Path to existing root of local CSIT git repository.
881     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
882     # Variables set:
883     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
884     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
885     # Functions called:
886     # - die - Print to stderr and exit.
887
888     set -exuo pipefail
889
890     case_text="${NODENESS}_${FLAVOR}"
891     case "${case_text}" in
892         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
893         # TODO: Double link availability depends on NIC used.
894         "1n_vbox")
895             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
896             TOPOLOGIES_TAGS="2_node_single_link_topo"
897             ;;
898         "1n_skx")
899             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
900             TOPOLOGIES_TAGS="2_node_single_link_topo"
901             ;;
902         "2n_skx")
903             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
904             TOPOLOGIES_TAGS="2_node_*_link_topo"
905             ;;
906         "3n_skx")
907             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
908             TOPOLOGIES_TAGS="3_node_*_link_topo"
909             ;;
910         "2n_dnv")
911             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
912             TOPOLOGIES_TAGS="2_node_single_link_topo"
913             ;;
914         "3n_dnv")
915             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
916             TOPOLOGIES_TAGS="3_node_single_link_topo"
917             ;;
918         "3n_hsw")
919             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
920             TOPOLOGIES_TAGS="3_node_single_link_topo"
921             ;;
922         "3n_tsh")
923             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
924             TOPOLOGIES_TAGS="3_node_*_link_topo"
925             ;;
926         *)
927             # No falling back to 3n_hsw default, that should have been done
928             # by the function which has set NODENESS and FLAVOR.
929             die "Unknown specification: ${case_text}"
930     esac
931
932     if [[ -z "${TOPOLOGIES-}" ]]; then
933         die "No applicable topology found!"
934     fi
935 }
936
937
938 function untrap_and_unreserve_testbed () {
939
940     # Use this as a trap function to ensure testbed does not remain reserved.
941     # Perhaps call directly before script exit, to free testbed for other jobs.
942     # This function is smart enough to avoid multiple unreservations (so safe).
943     # Topo cleanup is executed (call it best practice), ignoring failures.
944     #
945     # Hardcoded values:
946     # - default message to die with if testbed might remain reserved.
947     # Arguments:
948     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
949     # Variables read (by inner function):
950     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
951     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
952     # Variables written:
953     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
954     # Trap unregistered:
955     # - EXIT - Failure to untrap is reported, but ignored otherwise.
956     # Functions called:
957     # - die - Print to stderr and exit.
958
959     set -xo pipefail
960     set +eu  # We do not want to exit early in a "teardown" function.
961     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
962     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
963     if [[ -z "${wt-}" ]]; then
964         set -eu
965         warn "Testbed looks unreserved already. Trap removal failed before?"
966     else
967         cleanup_topo || true
968         python "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
969             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
970         }
971         WORKING_TOPOLOGY=""
972         set -eu
973     fi
974 }
975
976
977 function warn () {
978
979     # Print the message to standard error.
980     #
981     # Arguments:
982     # - ${@} - The text of the message.
983
984     set -exuo pipefail
985
986     echo "$@" >&2
987 }

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.